
#ifndef __TENTACLE__H___
#define __TENTACLE__H___

#include <vector>

using std::vector;

class GLUI;
class Tentacle;

typedef vector<Tentacle*>			TentacleVector;
typedef TentacleVector::iterator	TVIterator;

class Tentacle
{
public:
	Tentacle(float px, float py, float w, float h, float a, Tentacle *p);
	~Tentacle();


	void setupUI(GLUI *parent_win);
	void addChild(Tentacle *child);
	void setSelected(bool val);
	void glRender();

	Tentacle *getParent();
	Tentacle *nextSibling();
	Tentacle *firstChild();

private:

	Tentacle *nextChild(Tentacle *child);
	
	float positionX, positionY;
	float width, height;
	float angle;

	float r, g, b;

	bool selected;

	Tentacle *parent;

	TentacleVector children;
};


#endif //__TENTACLE__H___
